unit mainu;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls,math;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Game1: TMenuItem;
    Help1: TMenuItem;
    HelpTopics1: TMenuItem;
    About1: TMenuItem;
    New1: TMenuItem;
    N1: TMenuItem;
    Beginner1: TMenuItem;
    Intermediate1: TMenuItem;
    Expert1: TMenuItem;
    Custom1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    BestTimes1: TMenuItem;
    N4: TMenuItem;
    Marks1: TMenuItem;
    Colour1: TMenuItem;
    N5: TMenuItem;
    procedure SkillLevelClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Marks1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  procedure CreateField1(height1,width1,stars: integer);
  type
  spot = record
       num: byte;
       { each num is a value from 0 to 8, 0..7 having that many Stars in the
       surrounding 8, while 8 being an actual Star }
       display1: byte;
       { information on what should show up to the user
         0 = a simple tile that looks like a blank button
         1 = a question mark
         2 = a flag
         3 = a number or clicked tile, this means the num property should be used to deterStar the rest
         4 = a Star
         5 = a Star that exploded
         6 = a cross for a wrong guess
         7 = the 0 tile again, this is another way to display it.
         This is shown when the tile is down but not yet clicked
       }
  end;

var
  Form1: TForm1;
   field1: array of array of spot;
   // this contains the information on the Star field
   StarCount: integer; // the total # of Stars in the field
   emotion1: byte; // detreStars the type of facial expression to show to the user
   lastspot: tpoint; // the location of the last spot down
   displaya: array[0..13] of tbitmap;
   {
   0 = a blank light gray square
   1..7 = numbered (1..7)
   8 = a an untouched tile (looks like a blank button)
   9 = question mark
   10 = flag
   11 = the Star
   12 = the Star when hit (red background)
   13 = a cross(X) for wrong guesses
   }

const palette1: array[1..7] of tcolor = (clblue,clgreen,clred,clnavy,clmaroon,clOlive,clPurple);
      // the font colours of the numbers
const fexpress: array[0..3] of string = (':)',':o',':D',':x');
      // facial expressions
const left1 = 10;
      top1 = 56; // the top, left coordinates of the playing area

implementation

uses CustomFieldU;

{$R *.DFM}

procedure FrameRect2colours(can: tcanvas; rect1: trect; c1,c2: tcolor; w: byte);
{
 can = the canvas being drawn on
 rect1 = the rectangle being drawn
 c1 = the colour used for the upper left area
 c2 = the colour used for the lower right area of the rectangle
 w = the width of the frame                       }
var x: integer;
begin
     for x:=0 to w do
     with rect1 do
     begin
          can.pen.color:=c1;
          can.moveto(rect1.left+x,rect1.bottom-x);
          can.lineto(rect1.left+x,rect1.top+x);
          can.lineto(rect1.right-x,rect1.top+x);
          can.pen.color:=c2;
          can.lineto(rect1.right-x,rect1.bottom-x);
          can.lineto(rect1.left+x,rect1.bottom-x);
     end;
end;

procedure UpdateDisplay;
var
  bit1: tbitmap;
  x,y: integer;
  unknowns: integer; // a counter for the not yet uncovered spots
  remStars: integer; // a counter for the number of remaining Stars
  disn: integer;
  casev: integer;
begin
     bit1:=tbitmap.create;
     with bit1 do
     begin
          height:=form1.clientheight;
          width:=form1.clientwidth;
          canvas.font.name:='Arial';
          canvas.Brush.color:=clbtnface;
          canvas.FillRect(form1.clientrect);
          FrameRect2colours(canvas,form1.clientrect, clbtnhighlight,clbtnshadow,2);
          FrameRect2colours(canvas,rect(8,8,width-8,top1-10),clbtnshadow,clbtnhighlight,1);
          FrameRect2colours(canvas,rect(left1-3,top1-3,width-8,height-8),clbtnshadow,clbtnhighlight,1);
          disn:=0;
          unknowns:=0;
          remStars:=StarCount;
          for x:=high(Field1) downto 0 do
              for y:=high(Field1[0]) downto 0 do
              begin
                   casev:=Field1[x][y].display1;
                   case casev of
                    3: disn:=Field1[x][y].num;
                    0..2: disn:=8+casev;
                    4..6: disn:=7+casev;
                    7: disn:=0;
                   end;
                   if casev<>3 then
                      inc(unknowns);
                   if casev=2 then
                      dec(remStars);
                   canvas.draw(left1+x shl 4,top1+y shl 4,displaya[disn]);
              end;
          x:=width shr 1-5;
          with canvas do // draw the face
          begin
               brush.color:=clyellow;
               pen.color:=0;
               ellipse(x-5,17,x+11,33);
               brush.style:=bsclear;
               textout(x,17,fexpress[emotion1]);
               textout(left1+10,17,inttostr(remStars));
          end;
     end;
     form1.canvas.draw(0,0,bit1); // show the new screen to the user
     bit1.free;
     if (unknowns<=Starcount)and(emotion1<>2) then // the player won
     begin // the game was one and updatedisplay is not on a recursive call
          emotion1:=2; // :D
          UpdateDisplay; // show the new face
          ShowMessage('Congradulations!  You win.');
     end;
end;

procedure CreateField1(height1,width1,stars: integer);

  function This_is_a_star(x,y: integer): boolean;
  begin
       if (min(x,y)<0)or(x>=width1)or(y>=height1) then
          result:=false
       else
           result:=(field1[x,y].num=8); // result is true if that statement is tru
  end;

var
  x,y,z,z2: integer;
begin
     emotion1:=0;
     StarCount:=Stars;
     SetLength(field1,width1);
     for x:=width1-1 downto 0 do
     begin
          SetLength(field1[x],height1);
          for y:=height1-1 downto 0 do
          begin
               field1[x][y].num:=0;
               field1[x][y].display1:=0;
          end;
     end;
     // dimensions are now set and each spot is cleared of Stars

     z:=0;
     While (z<Stars) do
     begin
          x:=random(width1);
          y:=random(height1);
          if field1[x][y].num=0 then
          begin
               field1[x][y].num:=8; // becomes a Star
               inc(z);
          end;
     end;
     // now the Stars have been added to the field

     for x:=width1-1 downto 0 do
         for y:=height1-1 downto 0 do
             if field1[x][y].num=0 then
             begin
                  z2:=0;
                  for z:=0 to 8 do // loop through the surrounding 8 spots
                  // this also goes through [x,y] but who cares?
                     if This_is_a_Star(x+z mod 3-1,y + z div 3-1) then
                        inc(z2); // add the Star
                     field1[x][y].num:=z2;
             end;
     // now each spot also has the number of Stars around it counted

     Form1.ClientWidth:=20+width1 shl 4;
     Form1.ClientHeight:=66+height1 shl 4;
end;

procedure FinishGame;
var
  x,y: integer;
begin
     for x:=high(Field1) downto 0 do
         for y:=high(Field1[0]) downto 0 do
         begin
              if field1[x][y].num=8 then // its a Star
              begin
                   if field1[x][y].display1=0 then
                      field1[x][y].display1:=4;
              end
              else if field1[x][y].display1=2 then
                   field1[x][y].display1:=6; // the cross
         end;
     UpdateDisplay;
end;


procedure FloodZeros(x,y: integer);
// this does much the same as the floodfill API for graphics
   function This_is_a_zero(x3,y3: integer): boolean;
   begin
        if (min(x3,y3)<0)or(x3>high(Field1))or(y3>high(Field1[0])) then
           result:=false
        else
            result:=(field1[x3,y3].num=0); // result is true if that statement is tru
   end;

var
  x2,y2,z: integer;
  label EndPass;
begin
     for z:=0 to 8 do // loop for posible recursion
     begin
          x2:=x+z mod 3-1;
          y2:=y + z div 3-1;
          if (min(x2,y2)<0)or(x2>high(Field1))or(y2>high(Field1[0])) then
             Goto EndPass;
          if z<>4 then
             if This_is_a_zero(x2,y2) then
                if Field1[x2,y2].display1<>3 then
                   FloodZeros(x2,y2);
          Field1[x2,y2].display1:=3; // show the number
          EndPass:
     end;
end;

procedure TForm1.SkillLevelClick(Sender: TObject);
begin // a skill level was clicked from the menu.  This could be beginner... custom

     Beginner1.Checked:=false;
     Intermediate1.Checked:=false;
     Expert1.Checked:=false;
     Custom1.Checked:=false;
     if sender=Beginner1 then
     begin
          CreateField1(8,8,10);
          Beginner1.Checked:=true;
     end
     else if sender=Intermediate1 then
     begin
          CreateField1(16,16,40);
          Intermediate1.Checked:=true;
     end
     else if sender=Expert1 then
     begin
          CreateField1(16,30,99);
          Expert1.Checked:=true;
     end
     else
         CustomSkillFrm.ShowModal;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
     CreateField1(high(Field1[0])+1,high(Field1)+1,StarCount);
     UpdateDisplay;
end;

procedure TForm1.Marks1Click(Sender: TObject);
begin
     Marks1.Checked:=not Marks1.Checked;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
     ShowMessage( 'Starsweeper is open source.'+#13+
                  'This was written in Delphi 4 and '+#13+
                  'the source is freely available at www.planet-source-code.com'+#13+
                  'This program is a close copy of Microsoft''s Minesweeper so'+#13+
                  'this is far from original.'
                  );
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
     UpdateDisplay;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  x: integer;
  label endpass;

const
     rect1: trect = (left: 0;top: 0;right: 16;bottom: 16);
     TL = 4;
     TT = 1; // the locations of drawn text
begin
     randomize;
     emotion1:=0;
     SkillLevelClick(Intermediate1);
     for x:=0 to high(displaya) do // draw all of the graphics
     begin
          displaya[x]:=tbitmap.create;
          with displaya[x] do
          begin
               width:=16;
               height:=16;
               if x=12 then // the fatal Star
                  canvas.brush.color:=clred
               else
                   canvas.brush.color:=clbtnface;
               canvas.fillrect(rect1);
               canvas.pen.color:=clbtnshadow;
               canvas.rectangle(0,0,17,17);
               canvas.font.style:=[fsbold];
               if x=0 then
                  Goto EndPass;
               if (x<8) then
               begin
                    canvas.font.color:=palette1[x];
                    canvas.TextOut(TL,TT,inttostr(x));
               end
               else
                   case x of
                     8,9,10: with canvas do
                       begin // a an untouched tile (looks like a blank button)
                             pen.color:=clBtnHighlight;
                             moveto(0,16);
                             lineto(0,0);
                             lineto(15,0);
                             pen.color:=0;
                             lineto(15,15);
                             lineto(0,15);
                             pen.color:=clBtnShadow;
                             moveto(1,14);
                             lineto(14,14);
                             lineto(14,1);
                             pen.color:=0;
                             if x=9 then
                             begin // question mark
                                   canvas.Font.color:=clBlue;
                                   canvas.textout(TL,TT,'?');
                             end
                             else if x=10 then
                             begin // a flag
                                   brush.color:=clred;
                                   fillrect(rect(5,4,10,8));
                                   moveto(10,5);
                                   lineto(10,13);
                                   lineto(7,13);
                                   lineto(13,13);
                             end;
                     end;
                     11,12: with canvas do
                     begin // the star
                          brush.style:=bsclear;
                          textout(TL,TT,'+');
                          textout(TL,TT,'x');
                          // those 2 characters should work
                          brush.style:=bssolid;
                     end;
                     13: with canvas do
                     begin // the cross
                           font.color:=clred;
                           textout(TL,TT,'X');
                     end;//13 = a cross(X) for wrong guesses
                   end;
               EndPass:
          end;
     end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if emotion1>1 then
        exit;
     if (x>left1)and(y>top1) then
     begin
          x:=(x-left1) shr 4;
          y:=(y-top1) shr 4;
          if (x<=high(Field1))and(y<=high(Field1[0])) then // if in the playing area
          begin
               lastspot:=point(x,y);
               if (ssleft in Shift)and not (ssShift in Shift) then
               begin
                    if (Field1[x,y].display1<>3)and(field1[x,y].display1<>2) then
                       Field1[x,y].display1:=7; // show a blank tile until mouseup
               end
               else
               begin
                   case Field1[x,y].display1 of
                    0: Field1[x,y].display1:=2; // blank becomes flag
                    2: Field1[x,y].display1:=ord(Marks1.checked);
                    // flag becomes ? or blank depending on if the menu item is checked
                    1: Field1[x,y].display1:=0; // ? becomes blank
                    end;
               end;
          end;
     end;
     emotion1:=ord(ssleft in Shift);
     updatedisplay;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if emotion1>1 then
        exit;
     if ssShift in shift then
        exit;
     if (x>left1)and(y>top1) then // :o
     begin
          x:=(x-left1) shr 4;
          y:=(y-top1) shr 4;
          if Field1[lastspot.x,lastspot.y].display1=7 then
             Field1[lastspot.x,lastspot.y].display1:=0;
          if (x<=high(Field1))and(y<=high(Field1[0]))and(field1[x,y].display1<>2) then
          // if the point is in the playing area and
          begin
               if field1[x,y].num=8 then // clicking a Star, this might hurt
               begin
                    field1[x,y].display1:=5; // a blown up Star
                    emotion1:=3; // :x
                    FinishGame;
               end
               else 
               begin
                    field1[x,y].display1:=3; // show a number
                    if field1[x,y].num=0 then
                       FloodZeros(x,y);
               end;
          end;
     end;
     if emotion1<2 then
        emotion1:=ord(ssleft in Shift);
     updatedisplay;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
     randomize;
end;

end.
